/*     */ package org.apache.batik.svggen;
/*     */ 
/*     */ import java.awt.Image;
/*     */ import java.awt.image.RenderedImage;
/*     */ import java.awt.image.renderable.RenderableImage;
/*     */ import org.apache.batik.util.XMLConstants;
/*     */ import org.w3c.dom.Element;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class DefaultImageHandler
/*     */   implements ImageHandler, ErrorConstants, XMLConstants
/*     */ {
/*     */   public void handleImage(Image image, Element imageElement, SVGGeneratorContext generatorContext) {
/*  56 */     imageElement.setAttributeNS(null, "width", String.valueOf(image.getWidth(null)));
/*  57 */     imageElement.setAttributeNS(null, "height", String.valueOf(image.getHeight(null)));
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */     
/*  63 */     try { handleHREF(image, imageElement, generatorContext); }
/*     */     
/*  65 */     catch (SVGGraphics2DIOException e) { try {
/*  66 */         generatorContext.errorHandler.handleError(e);
/*     */       }
/*     */       catch (SVGGraphics2DIOException io) {
/*     */         
/*  70 */         throw new SVGGraphics2DRuntimeException(io);
/*     */       }  }
/*     */   
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void handleImage(RenderedImage image, Element imageElement, SVGGeneratorContext generatorContext) {
/*  84 */     imageElement.setAttributeNS(null, "width", String.valueOf(image.getWidth()));
/*  85 */     imageElement.setAttributeNS(null, "height", String.valueOf(image.getHeight()));
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */     
/*  91 */     try { handleHREF(image, imageElement, generatorContext); }
/*     */     
/*  93 */     catch (SVGGraphics2DIOException e) { try {
/*  94 */         generatorContext.errorHandler.handleError(e);
/*     */       }
/*     */       catch (SVGGraphics2DIOException io) {
/*     */         
/*  98 */         throw new SVGGraphics2DRuntimeException(io);
/*     */       }  }
/*     */   
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void handleImage(RenderableImage image, Element imageElement, SVGGeneratorContext generatorContext) {
/* 112 */     imageElement.setAttributeNS(null, "width", String.valueOf(image.getWidth()));
/* 113 */     imageElement.setAttributeNS(null, "height", String.valueOf(image.getHeight()));
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */     
/* 119 */     try { handleHREF(image, imageElement, generatorContext); }
/*     */     
/* 121 */     catch (SVGGraphics2DIOException e) { try {
/* 122 */         generatorContext.errorHandler.handleError(e);
/*     */       }
/*     */       catch (SVGGraphics2DIOException io) {
/*     */         
/* 126 */         throw new SVGGraphics2DRuntimeException(io);
/*     */       }  }
/*     */   
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 139 */   protected void handleHREF(Image image, Element imageElement, SVGGeneratorContext generatorContext) { imageElement.setAttributeNS("http://www.w3.org/1999/xlink", "xlink:href", image.toString()); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 151 */   protected void handleHREF(RenderedImage image, Element imageElement, SVGGeneratorContext generatorContext) { imageElement.setAttributeNS("http://www.w3.org/1999/xlink", "xlink:href", image.toString()); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 163 */   protected void handleHREF(RenderableImage image, Element imageElement, SVGGeneratorContext generatorContext) { imageElement.setAttributeNS("http://www.w3.org/1999/xlink", "xlink:href", image.toString()); }
/*     */ }


/* Location:              C:\Program Files (x86)\IBM\WebSphere\AppServer\profiles\ctgAppSrv01\installedApps\ctgCell01\MAXIMO.ear\maximouiweb.war\WEB-INF\classes\!\com\ibm\tivoli\maximo\report\control\svgtools\batik-svggen.jar!\org\apache\batik\svggen\DefaultImageHandler.class
 * Java compiler version: 1 (45.3)
 * JD-Core Version:       1.0.7
 */