/*     */ package org.apache.batik.svggen;
/*     */ 
/*     */ import java.util.HashMap;
/*     */ import java.util.LinkedList;
/*     */ import java.util.List;
/*     */ import java.util.Map;
/*     */ import org.apache.batik.ext.awt.g2d.GraphicContext;
/*     */ import org.apache.batik.ext.awt.g2d.TransformStackElement;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class SVGGraphicContextConverter
/*     */ {
/*     */   private static final int GRAPHIC_CONTEXT_CONVERTER_COUNT = 6;
/*     */   private SVGTransform transformConverter;
/*     */   private SVGPaint paintConverter;
/*     */   private SVGBasicStroke strokeConverter;
/*     */   private SVGComposite compositeConverter;
/*     */   private SVGClip clipConverter;
/*     */   private SVGRenderingHints hintsConverter;
/*     */   private SVGFont fontConverter;
/*  48 */   private SVGConverter[] converters = new SVGConverter[6];
/*     */ 
/*     */   
/*  51 */   public SVGTransform getTransformConverter() { return this.transformConverter; }
/*  52 */   public SVGPaint getPaintConverter() { return this.paintConverter; }
/*  53 */   public SVGBasicStroke getStrokeConverter() { return this.strokeConverter; }
/*  54 */   public SVGComposite getCompositeConverter() { return this.compositeConverter; }
/*  55 */   public SVGClip getClipConverter() { return this.clipConverter; }
/*  56 */   public SVGRenderingHints getHintsConverter() { return this.hintsConverter; }
/*  57 */   public SVGFont getFontConverter() { return this.fontConverter; }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public SVGGraphicContextConverter(SVGGeneratorContext generatorContext) {
/*  64 */     if (generatorContext == null) {
/*  65 */       throw new SVGGraphics2DRuntimeException("generatorContext should not be null");
/*     */     }
/*  67 */     this.transformConverter = new SVGTransform(generatorContext);
/*  68 */     this.paintConverter = new SVGPaint(generatorContext);
/*  69 */     this.strokeConverter = new SVGBasicStroke(generatorContext);
/*  70 */     this.compositeConverter = new SVGComposite(generatorContext);
/*  71 */     this.clipConverter = new SVGClip(generatorContext);
/*  72 */     this.hintsConverter = new SVGRenderingHints(generatorContext);
/*  73 */     this.fontConverter = new SVGFont(generatorContext);
/*     */     
/*  75 */     int i = 0;
/*  76 */     this.converters[i++] = this.paintConverter;
/*  77 */     this.converters[i++] = this.strokeConverter;
/*  78 */     this.converters[i++] = this.compositeConverter;
/*  79 */     this.converters[i++] = this.clipConverter;
/*  80 */     this.converters[i++] = this.hintsConverter;
/*  81 */     this.converters[i++] = this.fontConverter;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*  89 */   public String toSVG(TransformStackElement[] transformStack) { return this.transformConverter.toSVGTransform(transformStack); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public SVGGraphicContext toSVG(GraphicContext gc) {
/*  98 */     Map groupAttrMap = new HashMap();
/*     */     
/* 100 */     for (int i = 0; i < this.converters.length; i++) {
/* 101 */       SVGDescriptor desc = this.converters[i].toSVG(gc);
/* 102 */       if (desc != null) {
/* 103 */         desc.getAttributeMap(groupAttrMap);
/*     */       }
/*     */     } 
/*     */     
/* 107 */     return new SVGGraphicContext(groupAttrMap, gc.getTransformStack());
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public List getDefinitionSet() {
/* 116 */     List defSet = new LinkedList();
/* 117 */     for (int i = 0; i < this.converters.length; i++) {
/* 118 */       defSet.addAll(this.converters[i].getDefinitionSet());
/*     */     }
/* 120 */     return defSet;
/*     */   }
/*     */ }


/* Location:              C:\Program Files (x86)\IBM\WebSphere\AppServer\profiles\ctgAppSrv01\installedApps\ctgCell01\MAXIMO.ear\maximouiweb.war\WEB-INF\classes\!\com\ibm\tivoli\maximo\report\control\svgtools\batik-svggen.jar!\org\apache\batik\svggen\SVGGraphicContextConverter.class
 * Java compiler version: 1 (45.3)
 * JD-Core Version:       1.0.7
 */