/*     */ package org.apache.batik.svggen.font;
/*     */ 
/*     */ import java.io.File;
/*     */ import java.io.IOException;
/*     */ import java.io.RandomAccessFile;
/*     */ import org.apache.batik.svggen.font.table.CmapTable;
/*     */ import org.apache.batik.svggen.font.table.GlyfTable;
/*     */ import org.apache.batik.svggen.font.table.HeadTable;
/*     */ import org.apache.batik.svggen.font.table.HheaTable;
/*     */ import org.apache.batik.svggen.font.table.HmtxTable;
/*     */ import org.apache.batik.svggen.font.table.LocaTable;
/*     */ import org.apache.batik.svggen.font.table.MaxpTable;
/*     */ import org.apache.batik.svggen.font.table.NameTable;
/*     */ import org.apache.batik.svggen.font.table.Os2Table;
/*     */ import org.apache.batik.svggen.font.table.PostTable;
/*     */ import org.apache.batik.svggen.font.table.Table;
/*     */ import org.apache.batik.svggen.font.table.TableDirectory;
/*     */ import org.apache.batik.svggen.font.table.TableFactory;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class Font
/*     */ {
/*     */   private String path;
/*  49 */   private TableDirectory tableDirectory = null;
/*     */   
/*     */   private Table[] tables;
/*     */   
/*     */   private Os2Table os2;
/*     */   
/*     */   private CmapTable cmap;
/*     */   
/*     */   private GlyfTable glyf;
/*     */   
/*     */   private HeadTable head;
/*     */   
/*     */   private HheaTable hhea;
/*     */   private HmtxTable hmtx;
/*     */   private LocaTable loca;
/*     */   private MaxpTable maxp;
/*     */   private NameTable name;
/*     */   private PostTable post;
/*     */   
/*     */   public Table getTable(int tableType) {
/*  69 */     for (int i = 0; i < this.tables.length; i++) {
/*  70 */       if (this.tables[i] != null && this.tables[i].getType() == tableType) {
/*  71 */         return this.tables[i];
/*     */       }
/*     */     } 
/*  74 */     return null;
/*     */   }
/*     */ 
/*     */   
/*  78 */   public Os2Table getOS2Table() { return this.os2; }
/*     */ 
/*     */ 
/*     */   
/*  82 */   public CmapTable getCmapTable() { return this.cmap; }
/*     */ 
/*     */ 
/*     */   
/*  86 */   public HeadTable getHeadTable() { return this.head; }
/*     */ 
/*     */ 
/*     */   
/*  90 */   public HheaTable getHheaTable() { return this.hhea; }
/*     */ 
/*     */ 
/*     */   
/*  94 */   public HmtxTable getHmtxTable() { return this.hmtx; }
/*     */ 
/*     */ 
/*     */   
/*  98 */   public LocaTable getLocaTable() { return this.loca; }
/*     */ 
/*     */ 
/*     */   
/* 102 */   public MaxpTable getMaxpTable() { return this.maxp; }
/*     */ 
/*     */ 
/*     */   
/* 106 */   public NameTable getNameTable() { return this.name; }
/*     */ 
/*     */ 
/*     */   
/* 110 */   public PostTable getPostTable() { return this.post; }
/*     */ 
/*     */ 
/*     */   
/* 114 */   public int getAscent() { return this.hhea.getAscender(); }
/*     */ 
/*     */ 
/*     */   
/* 118 */   public int getDescent() { return this.hhea.getDescender(); }
/*     */ 
/*     */ 
/*     */   
/* 122 */   public int getNumGlyphs() { return this.maxp.getNumGlyphs(); }
/*     */ 
/*     */ 
/*     */   
/* 126 */   public Glyph getGlyph(int i) { return (this.glyf.getDescription(i) != null) ? new Glyph(this.glyf.getDescription(i), this.hmtx.getLeftSideBearing(i), this.hmtx.getAdvanceWidth(i)) : null; }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 135 */   public String getPath() { return this.path; }
/*     */ 
/*     */ 
/*     */   
/* 139 */   public TableDirectory getTableDirectory() { return this.tableDirectory; }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   protected void read(String pathName) {
/* 146 */     this.path = pathName;
/* 147 */     File f = new File(pathName);
/*     */     
/* 149 */     if (!f.exists()) {
/*     */       return;
/*     */     }
/*     */ 
/*     */     
/*     */     try {
/* 155 */       RandomAccessFile raf = new RandomAccessFile(f, "r");
/* 156 */       this.tableDirectory = new TableDirectory(raf);
/* 157 */       this.tables = new Table[this.tableDirectory.getNumTables()];
/*     */ 
/*     */       
/* 160 */       for (int i = 0; i < this.tableDirectory.getNumTables(); i++) {
/* 161 */         this.tables[i] = TableFactory.create(this.tableDirectory.getEntry(i), raf);
/*     */       }
/*     */       
/* 164 */       raf.close();
/*     */ 
/*     */       
/* 167 */       this.os2 = (Os2Table)getTable(1330851634);
/* 168 */       this.cmap = (CmapTable)getTable(1668112752);
/* 169 */       this.glyf = (GlyfTable)getTable(1735162214);
/* 170 */       this.head = (HeadTable)getTable(1751474532);
/* 171 */       this.hhea = (HheaTable)getTable(1751672161);
/* 172 */       this.hmtx = (HmtxTable)getTable(1752003704);
/* 173 */       this.loca = (LocaTable)getTable(1819239265);
/* 174 */       this.maxp = (MaxpTable)getTable(1835104368);
/* 175 */       this.name = (NameTable)getTable(1851878757);
/* 176 */       this.post = (PostTable)getTable(1886352244);
/*     */ 
/*     */       
/* 179 */       this.hmtx.init(this.hhea.getNumberOfHMetrics(), this.maxp.getNumGlyphs() - this.hhea.getNumberOfHMetrics());
/*     */       
/* 181 */       this.loca.init(this.maxp.getNumGlyphs(), (this.head.getIndexToLocFormat() == 0));
/* 182 */       this.glyf.init(this.maxp.getNumGlyphs(), this.loca);
/*     */     } catch (IOException e) {
/* 184 */       e.printStackTrace();
/*     */     } 
/*     */   }
/*     */ 
/*     */   
/* 189 */   public static Font create() { return new Font(); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public static Font create(String pathName) {
/* 196 */     Font f = new Font();
/* 197 */     f.read(pathName);
/* 198 */     return f;
/*     */   }
/*     */ }


/* Location:              C:\Program Files (x86)\IBM\WebSphere\AppServer\profiles\ctgAppSrv01\installedApps\ctgCell01\MAXIMO.ear\maximouiweb.war\WEB-INF\classes\!\com\ibm\tivoli\maximo\report\control\svgtools\batik-svggen.jar!\org\apache\batik\svggen\font\Font.class
 * Java compiler version: 1 (45.3)
 * JD-Core Version:       1.0.7
 */