/*     */ package org.apache.batik.svggen.font.table;
/*     */ 
/*     */ import java.io.ByteArrayInputStream;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class GlyfCompositeComp
/*     */ {
/*     */   public static final short ARG_1_AND_2_ARE_WORDS = 1;
/*     */   public static final short ARGS_ARE_XY_VALUES = 2;
/*     */   public static final short ROUND_XY_TO_GRID = 4;
/*     */   public static final short WE_HAVE_A_SCALE = 8;
/*     */   public static final short MORE_COMPONENTS = 32;
/*     */   public static final short WE_HAVE_AN_X_AND_Y_SCALE = 64;
/*     */   public static final short WE_HAVE_A_TWO_BY_TWO = 128;
/*     */   public static final short WE_HAVE_INSTRUCTIONS = 256;
/*     */   public static final short USE_MY_METRICS = 512;
/*     */   private int firstIndex;
/*     */   private int firstContour;
/*     */   private short argument1;
/*     */   private short argument2;
/*     */   private short flags;
/*     */   private int glyphIndex;
/*     */   private double xscale;
/*     */   private double yscale;
/*     */   private double scale01;
/*     */   private double scale10;
/*     */   private int xtranslate;
/*     */   private int ytranslate;
/*     */   private int point1;
/*     */   private int point2;
/*     */   
/*     */   protected GlyfCompositeComp(ByteArrayInputStream bais) {
/*  45 */     this.xscale = 1.0D;
/*  46 */     this.yscale = 1.0D;
/*  47 */     this.scale01 = 0.0D;
/*  48 */     this.scale10 = 0.0D;
/*  49 */     this.xtranslate = 0;
/*  50 */     this.ytranslate = 0;
/*  51 */     this.point1 = 0;
/*  52 */     this.point2 = 0;
/*     */ 
/*     */     
/*  55 */     this.flags = (short)(bais.read() << 8 | bais.read());
/*  56 */     this.glyphIndex = bais.read() << 8 | bais.read();
/*     */ 
/*     */     
/*  59 */     if ((this.flags & true) != 0) {
/*  60 */       this.argument1 = (short)(bais.read() << 8 | bais.read());
/*  61 */       this.argument2 = (short)(bais.read() << 8 | bais.read());
/*     */     } else {
/*  63 */       this.argument1 = (short)bais.read();
/*  64 */       this.argument2 = (short)bais.read();
/*     */     } 
/*     */ 
/*     */     
/*  68 */     if ((this.flags & 0x2) != 0) {
/*  69 */       this.xtranslate = this.argument1;
/*  70 */       this.ytranslate = this.argument2;
/*     */     } else {
/*  72 */       this.point1 = this.argument1;
/*  73 */       this.point2 = this.argument2;
/*     */     } 
/*     */ 
/*     */ 
/*     */     
/*  78 */     int i = (short)(bais.read() << 8 | bais.read());
/*  79 */     this.xscale = this.yscale = i / 16384.0D;
/*  80 */     if ((this.flags & 0x40) != 0) {
/*  81 */       short i = (short)(bais.read() << 8 | bais.read());
/*  82 */       this.xscale = i / 16384.0D;
/*  83 */       i = (short)(bais.read() << 8 | bais.read());
/*  84 */       this.yscale = i / 16384.0D;
/*  85 */     } else if ((this.flags & 0x80) != 0) {
/*  86 */       int i = (short)(bais.read() << 8 | bais.read());
/*  87 */       this.xscale = i / 16384.0D;
/*  88 */       i = (short)(bais.read() << 8 | bais.read());
/*  89 */       this.scale01 = i / 16384.0D;
/*  90 */       i = (short)(bais.read() << 8 | bais.read());
/*  91 */       this.scale10 = i / 16384.0D;
/*  92 */       i = (short)(bais.read() << 8 | bais.read());
/*  93 */       this.yscale = i / 16384.0D;
/*     */     } 
/*     */   }
/*     */ 
/*     */   
/*  98 */   public void setFirstIndex(int idx) { this.firstIndex = idx; }
/*     */ 
/*     */ 
/*     */   
/* 102 */   public int getFirstIndex() { return this.firstIndex; }
/*     */ 
/*     */ 
/*     */   
/* 106 */   public void setFirstContour(int idx) { this.firstContour = idx; }
/*     */ 
/*     */   
/* 109 */   public int getFirstContour() { return this.firstContour; }
/*     */ 
/*     */ 
/*     */   
/* 113 */   public short getArgument1() { return this.argument1; }
/*     */ 
/*     */ 
/*     */   
/* 117 */   public short getArgument2() { return this.argument2; }
/*     */ 
/*     */ 
/*     */   
/* 121 */   public short getFlags() { return this.flags; }
/*     */ 
/*     */ 
/*     */   
/* 125 */   public int getGlyphIndex() { return this.glyphIndex; }
/*     */ 
/*     */ 
/*     */   
/* 129 */   public double getScale01() { return this.scale01; }
/*     */ 
/*     */ 
/*     */   
/* 133 */   public double getScale10() { return this.scale10; }
/*     */ 
/*     */ 
/*     */   
/* 137 */   public double getXScale() { return this.xscale; }
/*     */ 
/*     */ 
/*     */   
/* 141 */   public double getYScale() { return this.yscale; }
/*     */ 
/*     */ 
/*     */   
/* 145 */   public int getXTranslate() { return this.xtranslate; }
/*     */ 
/*     */ 
/*     */   
/* 149 */   public int getYTranslate() { return this.ytranslate; }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 159 */   public int scaleX(int x, int y) { return Math.round((float)(x * this.xscale + y * this.scale10)); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 169 */   public int scaleY(int x, int y) { return Math.round((float)(x * this.scale01 + y * this.yscale)); }
/*     */ }


/* Location:              C:\Program Files (x86)\IBM\WebSphere\AppServer\profiles\ctgAppSrv01\installedApps\ctgCell01\MAXIMO.ear\maximouiweb.war\WEB-INF\classes\!\com\ibm\tivoli\maximo\report\control\svgtools\batik-svggen.jar!\org\apache\batik\svggen\font\table\GlyfCompositeComp.class
 * Java compiler version: 1 (45.3)
 * JD-Core Version:       1.0.7
 */