/*     */ package org.apache.batik.svggen.font.table;
/*     */ 
/*     */ import java.io.IOException;
/*     */ import java.io.RandomAccessFile;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class HeadTable
/*     */   implements Table
/*     */ {
/*     */   private int versionNumber;
/*     */   private int fontRevision;
/*     */   private int checkSumAdjustment;
/*     */   private int magicNumber;
/*     */   private short flags;
/*     */   private short unitsPerEm;
/*     */   private long created;
/*     */   private long modified;
/*     */   private short xMin;
/*     */   private short yMin;
/*     */   private short xMax;
/*     */   private short yMax;
/*     */   private short macStyle;
/*     */   private short lowestRecPPEM;
/*     */   private short fontDirectionHint;
/*     */   private short indexToLocFormat;
/*     */   private short glyphDataFormat;
/*     */   
/*     */   protected HeadTable(DirectoryEntry de, RandomAccessFile raf) throws IOException {
/*  49 */     raf.seek(de.getOffset());
/*  50 */     this.versionNumber = raf.readInt();
/*  51 */     this.fontRevision = raf.readInt();
/*  52 */     this.checkSumAdjustment = raf.readInt();
/*  53 */     this.magicNumber = raf.readInt();
/*  54 */     this.flags = raf.readShort();
/*  55 */     this.unitsPerEm = raf.readShort();
/*  56 */     this.created = raf.readLong();
/*  57 */     this.modified = raf.readLong();
/*  58 */     this.xMin = raf.readShort();
/*  59 */     this.yMin = raf.readShort();
/*  60 */     this.xMax = raf.readShort();
/*  61 */     this.yMax = raf.readShort();
/*  62 */     this.macStyle = raf.readShort();
/*  63 */     this.lowestRecPPEM = raf.readShort();
/*  64 */     this.fontDirectionHint = raf.readShort();
/*  65 */     this.indexToLocFormat = raf.readShort();
/*  66 */     this.glyphDataFormat = raf.readShort();
/*     */   }
/*     */ 
/*     */   
/*  70 */   public int getCheckSumAdjustment() { return this.checkSumAdjustment; }
/*     */ 
/*     */ 
/*     */   
/*  74 */   public long getCreated() { return this.created; }
/*     */ 
/*     */ 
/*     */   
/*  78 */   public short getFlags() { return this.flags; }
/*     */ 
/*     */ 
/*     */   
/*  82 */   public short getFontDirectionHint() { return this.fontDirectionHint; }
/*     */ 
/*     */ 
/*     */   
/*  86 */   public int getFontRevision() { return this.fontRevision; }
/*     */ 
/*     */ 
/*     */   
/*  90 */   public short getGlyphDataFormat() { return this.glyphDataFormat; }
/*     */ 
/*     */ 
/*     */   
/*  94 */   public short getIndexToLocFormat() { return this.indexToLocFormat; }
/*     */ 
/*     */ 
/*     */   
/*  98 */   public short getLowestRecPPEM() { return this.lowestRecPPEM; }
/*     */ 
/*     */ 
/*     */   
/* 102 */   public short getMacStyle() { return this.macStyle; }
/*     */ 
/*     */ 
/*     */   
/* 106 */   public long getModified() { return this.modified; }
/*     */ 
/*     */ 
/*     */   
/* 110 */   public int getType() { return 1751474532; }
/*     */ 
/*     */ 
/*     */   
/* 114 */   public short getUnitsPerEm() { return this.unitsPerEm; }
/*     */ 
/*     */ 
/*     */   
/* 118 */   public int getVersionNumber() { return this.versionNumber; }
/*     */ 
/*     */ 
/*     */   
/* 122 */   public short getXMax() { return this.xMax; }
/*     */ 
/*     */ 
/*     */   
/* 126 */   public short getXMin() { return this.xMin; }
/*     */ 
/*     */ 
/*     */   
/* 130 */   public short getYMax() { return this.yMax; }
/*     */ 
/*     */ 
/*     */   
/* 134 */   public short getYMin() { return this.yMin; }
/*     */ 
/*     */ 
/*     */   
/* 138 */   public String toString() { return "head\n\tversionNumber: " + this.versionNumber + "\n\tfontRevision: " + this.fontRevision + "\n\tcheckSumAdjustment: " + this.checkSumAdjustment + "\n\tmagicNumber: " + this.magicNumber + "\n\tflags: " + this.flags + "\n\tunitsPerEm: " + this.unitsPerEm + "\n\tcreated: " + this.created + "\n\tmodified: " + this.modified + "\n\txMin: " + this.xMin + ", yMin: " + this.yMin + "\n\txMax: " + this.xMax + ", yMax: " + this.yMax + "\n\tmacStyle: " + this.macStyle + "\n\tlowestRecPPEM: " + this.lowestRecPPEM + "\n\tfontDirectionHint: " + this.fontDirectionHint + "\n\tindexToLocFormat: " + this.indexToLocFormat + "\n\tglyphDataFormat: " + this.glyphDataFormat; }
/*     */ }


/* Location:              C:\Program Files (x86)\IBM\WebSphere\AppServer\profiles\ctgAppSrv01\installedApps\ctgCell01\MAXIMO.ear\maximouiweb.war\WEB-INF\classes\!\com\ibm\tivoli\maximo\report\control\svgtools\batik-svggen.jar!\org\apache\batik\svggen\font\table\HeadTable.class
 * Java compiler version: 1 (45.3)
 * JD-Core Version:       1.0.7
 */