/*     */ package org.apache.batik.svggen.font.table;
/*     */ 
/*     */ import java.io.IOException;
/*     */ import java.io.RandomAccessFile;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class MaxpTable
/*     */   implements Table
/*     */ {
/*     */   private int versionNumber;
/*     */   private int numGlyphs;
/*     */   private int maxPoints;
/*     */   private int maxContours;
/*     */   private int maxCompositePoints;
/*     */   private int maxCompositeContours;
/*     */   private int maxZones;
/*     */   private int maxTwilightPoints;
/*     */   private int maxStorage;
/*     */   private int maxFunctionDefs;
/*     */   private int maxInstructionDefs;
/*     */   private int maxStackElements;
/*     */   private int maxSizeOfInstructions;
/*     */   private int maxComponentElements;
/*     */   private int maxComponentDepth;
/*     */   
/*     */   protected MaxpTable(DirectoryEntry de, RandomAccessFile raf) throws IOException {
/*  47 */     raf.seek(de.getOffset());
/*  48 */     this.versionNumber = raf.readInt();
/*  49 */     this.numGlyphs = raf.readUnsignedShort();
/*  50 */     this.maxPoints = raf.readUnsignedShort();
/*  51 */     this.maxContours = raf.readUnsignedShort();
/*  52 */     this.maxCompositePoints = raf.readUnsignedShort();
/*  53 */     this.maxCompositeContours = raf.readUnsignedShort();
/*  54 */     this.maxZones = raf.readUnsignedShort();
/*  55 */     this.maxTwilightPoints = raf.readUnsignedShort();
/*  56 */     this.maxStorage = raf.readUnsignedShort();
/*  57 */     this.maxFunctionDefs = raf.readUnsignedShort();
/*  58 */     this.maxInstructionDefs = raf.readUnsignedShort();
/*  59 */     this.maxStackElements = raf.readUnsignedShort();
/*  60 */     this.maxSizeOfInstructions = raf.readUnsignedShort();
/*  61 */     this.maxComponentElements = raf.readUnsignedShort();
/*  62 */     this.maxComponentDepth = raf.readUnsignedShort();
/*     */   }
/*     */ 
/*     */   
/*  66 */   public int getMaxComponentDepth() { return this.maxComponentDepth; }
/*     */ 
/*     */ 
/*     */   
/*  70 */   public int getMaxComponentElements() { return this.maxComponentElements; }
/*     */ 
/*     */ 
/*     */   
/*  74 */   public int getMaxCompositeContours() { return this.maxCompositeContours; }
/*     */ 
/*     */ 
/*     */   
/*  78 */   public int getMaxCompositePoints() { return this.maxCompositePoints; }
/*     */ 
/*     */ 
/*     */   
/*  82 */   public int getMaxContours() { return this.maxContours; }
/*     */ 
/*     */ 
/*     */   
/*  86 */   public int getMaxFunctionDefs() { return this.maxFunctionDefs; }
/*     */ 
/*     */ 
/*     */   
/*  90 */   public int getMaxInstructionDefs() { return this.maxInstructionDefs; }
/*     */ 
/*     */ 
/*     */   
/*  94 */   public int getMaxPoints() { return this.maxPoints; }
/*     */ 
/*     */ 
/*     */   
/*  98 */   public int getMaxSizeOfInstructions() { return this.maxSizeOfInstructions; }
/*     */ 
/*     */ 
/*     */   
/* 102 */   public int getMaxStackElements() { return this.maxStackElements; }
/*     */ 
/*     */ 
/*     */   
/* 106 */   public int getMaxStorage() { return this.maxStorage; }
/*     */ 
/*     */ 
/*     */   
/* 110 */   public int getMaxTwilightPoints() { return this.maxTwilightPoints; }
/*     */ 
/*     */ 
/*     */   
/* 114 */   public int getMaxZones() { return this.maxZones; }
/*     */ 
/*     */ 
/*     */   
/* 118 */   public int getNumGlyphs() { return this.numGlyphs; }
/*     */ 
/*     */ 
/*     */   
/* 122 */   public int getType() { return 1835104368; }
/*     */ }


/* Location:              C:\Program Files (x86)\IBM\WebSphere\AppServer\profiles\ctgAppSrv01\installedApps\ctgCell01\MAXIMO.ear\maximouiweb.war\WEB-INF\classes\!\com\ibm\tivoli\maximo\report\control\svgtools\batik-svggen.jar!\org\apache\batik\svggen\font\table\MaxpTable.class
 * Java compiler version: 1 (45.3)
 * JD-Core Version:       1.0.7
 */