/*     */ package org.apache.batik.svggen.font.table;
/*     */ 
/*     */ import java.io.IOException;
/*     */ import java.io.RandomAccessFile;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class Os2Table
/*     */   implements Table
/*     */ {
/*     */   private int version;
/*     */   private short xAvgCharWidth;
/*     */   private int usWeightClass;
/*     */   private int usWidthClass;
/*     */   private short fsType;
/*     */   private short ySubscriptXSize;
/*     */   private short ySubscriptYSize;
/*     */   private short ySubscriptXOffset;
/*     */   private short ySubscriptYOffset;
/*     */   private short ySuperscriptXSize;
/*     */   private short ySuperscriptYSize;
/*     */   private short ySuperscriptXOffset;
/*     */   private short ySuperscriptYOffset;
/*     */   private short yStrikeoutSize;
/*     */   private short yStrikeoutPosition;
/*     */   private short sFamilyClass;
/*     */   private Panose panose;
/*     */   private int ulUnicodeRange1;
/*     */   private int ulUnicodeRange2;
/*     */   private int ulUnicodeRange3;
/*     */   private int ulUnicodeRange4;
/*     */   private int achVendorID;
/*     */   private short fsSelection;
/*     */   private int usFirstCharIndex;
/*     */   private int usLastCharIndex;
/*     */   private short sTypoAscender;
/*     */   private short sTypoDescender;
/*     */   private short sTypoLineGap;
/*     */   private int usWinAscent;
/*     */   private int usWinDescent;
/*     */   private int ulCodePageRange1;
/*     */   private int ulCodePageRange2;
/*     */   
/*     */   protected Os2Table(DirectoryEntry de, RandomAccessFile raf) throws IOException {
/*  64 */     raf.seek(de.getOffset());
/*  65 */     this.version = raf.readUnsignedShort();
/*  66 */     this.xAvgCharWidth = raf.readShort();
/*  67 */     this.usWeightClass = raf.readUnsignedShort();
/*  68 */     this.usWidthClass = raf.readUnsignedShort();
/*  69 */     this.fsType = raf.readShort();
/*  70 */     this.ySubscriptXSize = raf.readShort();
/*  71 */     this.ySubscriptYSize = raf.readShort();
/*  72 */     this.ySubscriptXOffset = raf.readShort();
/*  73 */     this.ySubscriptYOffset = raf.readShort();
/*  74 */     this.ySuperscriptXSize = raf.readShort();
/*  75 */     this.ySuperscriptYSize = raf.readShort();
/*  76 */     this.ySuperscriptXOffset = raf.readShort();
/*  77 */     this.ySuperscriptYOffset = raf.readShort();
/*  78 */     this.yStrikeoutSize = raf.readShort();
/*  79 */     this.yStrikeoutPosition = raf.readShort();
/*  80 */     this.sFamilyClass = raf.readShort();
/*  81 */     byte[] buf = new byte[10];
/*  82 */     raf.read(buf);
/*  83 */     this.panose = new Panose(buf);
/*  84 */     this.ulUnicodeRange1 = raf.readInt();
/*  85 */     this.ulUnicodeRange2 = raf.readInt();
/*  86 */     this.ulUnicodeRange3 = raf.readInt();
/*  87 */     this.ulUnicodeRange4 = raf.readInt();
/*  88 */     this.achVendorID = raf.readInt();
/*  89 */     this.fsSelection = raf.readShort();
/*  90 */     this.usFirstCharIndex = raf.readUnsignedShort();
/*  91 */     this.usLastCharIndex = raf.readUnsignedShort();
/*  92 */     this.sTypoAscender = raf.readShort();
/*  93 */     this.sTypoDescender = raf.readShort();
/*  94 */     this.sTypoLineGap = raf.readShort();
/*  95 */     this.usWinAscent = raf.readUnsignedShort();
/*  96 */     this.usWinDescent = raf.readUnsignedShort();
/*  97 */     this.ulCodePageRange1 = raf.readInt();
/*  98 */     this.ulCodePageRange2 = raf.readInt();
/*     */   }
/*     */ 
/*     */   
/* 102 */   public int getVersion() { return this.version; }
/*     */ 
/*     */ 
/*     */   
/* 106 */   public short getAvgCharWidth() { return this.xAvgCharWidth; }
/*     */ 
/*     */ 
/*     */   
/* 110 */   public int getWeightClass() { return this.usWeightClass; }
/*     */ 
/*     */ 
/*     */   
/* 114 */   public int getWidthClass() { return this.usWidthClass; }
/*     */ 
/*     */ 
/*     */   
/* 118 */   public short getLicenseType() { return this.fsType; }
/*     */ 
/*     */ 
/*     */   
/* 122 */   public short getSubscriptXSize() { return this.ySubscriptXSize; }
/*     */ 
/*     */ 
/*     */   
/* 126 */   public short getSubscriptYSize() { return this.ySubscriptYSize; }
/*     */ 
/*     */ 
/*     */   
/* 130 */   public short getSubscriptXOffset() { return this.ySubscriptXOffset; }
/*     */ 
/*     */ 
/*     */   
/* 134 */   public short getSubscriptYOffset() { return this.ySubscriptYOffset; }
/*     */ 
/*     */ 
/*     */   
/* 138 */   public short getSuperscriptXSize() { return this.ySuperscriptXSize; }
/*     */ 
/*     */ 
/*     */   
/* 142 */   public short getSuperscriptYSize() { return this.ySuperscriptYSize; }
/*     */ 
/*     */ 
/*     */   
/* 146 */   public short getSuperscriptXOffset() { return this.ySuperscriptXOffset; }
/*     */ 
/*     */ 
/*     */   
/* 150 */   public short getSuperscriptYOffset() { return this.ySuperscriptYOffset; }
/*     */ 
/*     */ 
/*     */   
/* 154 */   public short getStrikeoutSize() { return this.yStrikeoutSize; }
/*     */ 
/*     */ 
/*     */   
/* 158 */   public short getStrikeoutPosition() { return this.yStrikeoutPosition; }
/*     */ 
/*     */ 
/*     */   
/* 162 */   public short getFamilyClass() { return this.sFamilyClass; }
/*     */ 
/*     */ 
/*     */   
/* 166 */   public Panose getPanose() { return this.panose; }
/*     */ 
/*     */ 
/*     */   
/* 170 */   public int getUnicodeRange1() { return this.ulUnicodeRange1; }
/*     */ 
/*     */ 
/*     */   
/* 174 */   public int getUnicodeRange2() { return this.ulUnicodeRange2; }
/*     */ 
/*     */ 
/*     */   
/* 178 */   public int getUnicodeRange3() { return this.ulUnicodeRange3; }
/*     */ 
/*     */ 
/*     */   
/* 182 */   public int getUnicodeRange4() { return this.ulUnicodeRange4; }
/*     */ 
/*     */ 
/*     */   
/* 186 */   public int getVendorID() { return this.achVendorID; }
/*     */ 
/*     */ 
/*     */   
/* 190 */   public short getSelection() { return this.fsSelection; }
/*     */ 
/*     */ 
/*     */   
/* 194 */   public int getFirstCharIndex() { return this.usFirstCharIndex; }
/*     */ 
/*     */ 
/*     */   
/* 198 */   public int getLastCharIndex() { return this.usLastCharIndex; }
/*     */ 
/*     */ 
/*     */   
/* 202 */   public short getTypoAscender() { return this.sTypoAscender; }
/*     */ 
/*     */ 
/*     */   
/* 206 */   public short getTypoDescender() { return this.sTypoDescender; }
/*     */ 
/*     */ 
/*     */   
/* 210 */   public short getTypoLineGap() { return this.sTypoLineGap; }
/*     */ 
/*     */ 
/*     */   
/* 214 */   public int getWinAscent() { return this.usWinAscent; }
/*     */ 
/*     */ 
/*     */   
/* 218 */   public int getWinDescent() { return this.usWinDescent; }
/*     */ 
/*     */ 
/*     */   
/* 222 */   public int getCodePageRange1() { return this.ulCodePageRange1; }
/*     */ 
/*     */ 
/*     */   
/* 226 */   public int getCodePageRange2() { return this.ulCodePageRange2; }
/*     */ 
/*     */ 
/*     */   
/* 230 */   public int getType() { return 1330851634; }
/*     */ }


/* Location:              C:\Program Files (x86)\IBM\WebSphere\AppServer\profiles\ctgAppSrv01\installedApps\ctgCell01\MAXIMO.ear\maximouiweb.war\WEB-INF\classes\!\com\ibm\tivoli\maximo\report\control\svgtools\batik-svggen.jar!\org\apache\batik\svggen\font\table\Os2Table.class
 * Java compiler version: 1 (45.3)
 * JD-Core Version:       1.0.7
 */