/*    */ package org.apache.batik.svggen;
/*    */ 
/*    */ import java.util.HashMap;
/*    */ import java.util.HashSet;
/*    */ import java.util.Iterator;
/*    */ import java.util.Map;
/*    */ import java.util.Set;
/*    */ import org.apache.batik.util.SVGConstants;
/*    */ import org.w3c.dom.Element;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ public class DefaultStyleHandler
/*    */   implements StyleHandler, SVGConstants
/*    */ {
/* 47 */   static Map ignoreAttributes = new HashMap();
/*    */ 
/*    */   
/*    */   static  {
/* 51 */     textAttributes = new HashSet();
/* 52 */     textAttributes.add("font-size");
/* 53 */     textAttributes.add("font-family");
/* 54 */     textAttributes.add("font-style");
/* 55 */     textAttributes.add("font-weight");
/*    */     
/* 57 */     ignoreAttributes.put("rect", textAttributes);
/* 58 */     ignoreAttributes.put("circle", textAttributes);
/* 59 */     ignoreAttributes.put("ellipse", textAttributes);
/* 60 */     ignoreAttributes.put("polygon", textAttributes);
/* 61 */     ignoreAttributes.put("polygon", textAttributes);
/* 62 */     ignoreAttributes.put("line", textAttributes);
/* 63 */     ignoreAttributes.put("path", textAttributes);
/*    */   }
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */   
/*    */   public void setStyle(Element element, Map styleMap, SVGGeneratorContext generatorContext) {
/* 76 */     String tagName = element.getTagName();
/* 77 */     Iterator iter = styleMap.keySet().iterator();
/* 78 */     while (iter.hasNext()) {
/* 79 */       String styleName = (String)iter.next();
/* 80 */       if (element.getAttributeNS(null, styleName).length() == 0 && 
/* 81 */         appliesTo(styleName, tagName)) {
/* 82 */         element.setAttributeNS(null, styleName, (String)styleMap.get(styleName));
/*    */       }
/*    */     } 
/*    */   }
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */   
/*    */   protected boolean appliesTo(String styleName, String tagName) {
/* 94 */     Set s = (Set)ignoreAttributes.get(tagName);
/* 95 */     if (s == null) {
/* 96 */       return true;
/*    */     }
/* 98 */     return !s.contains(styleName);
/*    */   }
/*    */ }


/* Location:              C:\Program Files (x86)\IBM\WebSphere\AppServer\profiles\ctgAppSrv01\installedApps\ctgCell01\MAXIMO.ear\maximouiweb.war\WEB-INF\classes\!\com\ibm\tivoli\maximo\report\control\svgtools\batik-svggen.jar!\org\apache\batik\svggen\DefaultStyleHandler.class
 * Java compiler version: 1 (45.3)
 * JD-Core Version:       1.0.7
 */