/*     */ package org.apache.batik.svggen;
/*     */ 
/*     */ import java.awt.Dimension;
/*     */ import java.awt.image.BufferedImage;
/*     */ import java.io.File;
/*     */ import java.io.FileOutputStream;
/*     */ import java.io.IOException;
/*     */ import java.io.OutputStream;
/*     */ import org.apache.batik.ext.awt.image.spi.ImageWriter;
/*     */ import org.apache.batik.ext.awt.image.spi.ImageWriterParams;
/*     */ import org.apache.batik.ext.awt.image.spi.ImageWriterRegistry;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class ImageHandlerJPEGEncoder
/*     */   extends AbstractImageHandlerEncoder
/*     */ {
/*  54 */   public ImageHandlerJPEGEncoder(String imageDir, String urlRoot) throws SVGGraphics2DIOException { super(imageDir, urlRoot); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*  62 */   public final String getSuffix() { return ".jpg"; }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*  70 */   public final String getPrefix() { return "jpegImage"; }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void encodeImage(BufferedImage buf, File imageFile) throws SVGGraphics2DIOException {
/*     */     try {
/*  80 */       OutputStream os = new FileOutputStream(imageFile);
/*     */       try {
/*  82 */         ImageWriter writer = ImageWriterRegistry.getInstance().getWriterFor("image/jpeg");
/*     */         
/*  84 */         ImageWriterParams params = new ImageWriterParams();
/*  85 */         params.setJPEGQuality(1.0F, false);
/*  86 */         writer.writeImage(buf, os, params);
/*     */       } finally {
/*     */         
/*  89 */         os.close();
/*     */       } 
/*     */     } catch (IOException e) {
/*  92 */       throw new SVGGraphics2DIOException("could not write image File " + imageFile.getName());
/*     */     } 
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 101 */   public BufferedImage buildBufferedImage(Dimension size) { return new BufferedImage(size.width, size.height, 1); }
/*     */ }


/* Location:              C:\Program Files (x86)\IBM\WebSphere\AppServer\profiles\ctgAppSrv01\installedApps\ctgCell01\MAXIMO.ear\maximouiweb.war\WEB-INF\classes\!\com\ibm\tivoli\maximo\report\control\svgtools\batik-svggen.jar!\org\apache\batik\svggen\ImageHandlerJPEGEncoder.class
 * Java compiler version: 1 (45.3)
 * JD-Core Version:       1.0.7
 */