/*     */ package org.apache.batik.svggen;
/*     */ 
/*     */ import java.awt.AlphaComposite;
/*     */ import java.awt.Composite;
/*     */ import java.util.LinkedList;
/*     */ import java.util.List;
/*     */ import org.apache.batik.ext.awt.g2d.GraphicContext;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class SVGComposite
/*     */   implements SVGConverter
/*     */ {
/*     */   private SVGAlphaComposite svgAlphaComposite;
/*     */   private SVGCustomComposite svgCustomComposite;
/*     */   
/*     */   public SVGComposite(SVGGeneratorContext generatorContext) {
/*  61 */     this.svgAlphaComposite = new SVGAlphaComposite(generatorContext);
/*  62 */     this.svgCustomComposite = new SVGCustomComposite(generatorContext);
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public List getDefinitionSet() {
/*  70 */     List compositeDefs = new LinkedList(this.svgAlphaComposite.getDefinitionSet());
/*  71 */     compositeDefs.addAll(this.svgCustomComposite.getDefinitionSet());
/*  72 */     return compositeDefs;
/*     */   }
/*     */ 
/*     */   
/*  76 */   public SVGAlphaComposite getAlphaCompositeConverter() { return this.svgAlphaComposite; }
/*     */ 
/*     */ 
/*     */   
/*  80 */   public SVGCustomComposite getCustomCompositeConverter() { return this.svgCustomComposite; }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*  94 */   public SVGDescriptor toSVG(GraphicContext gc) { return toSVG(gc.getComposite()); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public SVGCompositeDescriptor toSVG(Composite composite) {
/* 103 */     if (composite instanceof AlphaComposite) {
/* 104 */       return this.svgAlphaComposite.toSVG((AlphaComposite)composite);
/*     */     }
/* 106 */     return this.svgCustomComposite.toSVG(composite);
/*     */   }
/*     */ }


/* Location:              C:\Program Files (x86)\IBM\WebSphere\AppServer\profiles\ctgAppSrv01\installedApps\ctgCell01\MAXIMO.ear\maximouiweb.war\WEB-INF\classes\!\com\ibm\tivoli\maximo\report\control\svgtools\batik-svggen.jar!\org\apache\batik\svggen\SVGComposite.class
 * Java compiler version: 1 (45.3)
 * JD-Core Version:       1.0.7
 */