/*     */ package org.apache.batik.svggen;
/*     */ 
/*     */ import java.awt.Color;
/*     */ import java.awt.GradientPaint;
/*     */ import java.awt.Paint;
/*     */ import java.awt.TexturePaint;
/*     */ import java.util.LinkedList;
/*     */ import java.util.List;
/*     */ import org.apache.batik.ext.awt.g2d.GraphicContext;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class SVGPaint
/*     */   implements SVGConverter
/*     */ {
/*     */   private SVGLinearGradient svgLinearGradient;
/*     */   private SVGTexturePaint svgTexturePaint;
/*     */   private SVGColor svgColor;
/*     */   private SVGCustomPaint svgCustomPaint;
/*     */   private SVGGeneratorContext generatorContext;
/*     */   
/*     */   public SVGPaint(SVGGeneratorContext generatorContext) {
/*  70 */     this.svgLinearGradient = new SVGLinearGradient(generatorContext);
/*  71 */     this.svgTexturePaint = new SVGTexturePaint(generatorContext);
/*  72 */     this.svgCustomPaint = new SVGCustomPaint(generatorContext);
/*  73 */     this.svgColor = new SVGColor(generatorContext);
/*  74 */     this.generatorContext = generatorContext;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public List getDefinitionSet() {
/*  82 */     List paintDefs = new LinkedList(this.svgLinearGradient.getDefinitionSet());
/*  83 */     paintDefs.addAll(this.svgTexturePaint.getDefinitionSet());
/*  84 */     paintDefs.addAll(this.svgCustomPaint.getDefinitionSet());
/*  85 */     paintDefs.addAll(this.svgColor.getDefinitionSet());
/*  86 */     return paintDefs;
/*     */   }
/*     */ 
/*     */   
/*  90 */   public SVGTexturePaint getTexturePaintConverter() { return this.svgTexturePaint; }
/*     */ 
/*     */ 
/*     */   
/*  94 */   public SVGLinearGradient getGradientPaintConverter() { return this.svgLinearGradient; }
/*     */ 
/*     */ 
/*     */   
/*  98 */   public SVGCustomPaint getCustomPaintConverter() { return this.svgCustomPaint; }
/*     */ 
/*     */ 
/*     */   
/* 102 */   public SVGColor getColorConverter() { return this.svgColor; }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 116 */   public SVGDescriptor toSVG(GraphicContext gc) { return toSVG(gc.getPaint()); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public SVGPaintDescriptor toSVG(Paint paint) {
/* 126 */     SVGPaintDescriptor paintDesc = this.svgCustomPaint.toSVG(paint);
/*     */     
/* 128 */     if (paintDesc == null) {
/* 129 */       if (paint instanceof Color) {
/* 130 */         paintDesc = SVGColor.toSVG((Color)paint, this.generatorContext);
/* 131 */       } else if (paint instanceof GradientPaint) {
/* 132 */         paintDesc = this.svgLinearGradient.toSVG((GradientPaint)paint);
/* 133 */       } else if (paint instanceof TexturePaint) {
/* 134 */         paintDesc = this.svgTexturePaint.toSVG((TexturePaint)paint);
/*     */       } 
/*     */     }
/* 137 */     return paintDesc;
/*     */   }
/*     */ }


/* Location:              C:\Program Files (x86)\IBM\WebSphere\AppServer\profiles\ctgAppSrv01\installedApps\ctgCell01\MAXIMO.ear\maximouiweb.war\WEB-INF\classes\!\com\ibm\tivoli\maximo\report\control\svgtools\batik-svggen.jar!\org\apache\batik\svggen\SVGPaint.class
 * Java compiler version: 1 (45.3)
 * JD-Core Version:       1.0.7
 */