/*    */ package org.apache.batik.svggen;
/*    */ 
/*    */ import java.util.HashMap;
/*    */ import java.util.LinkedList;
/*    */ import java.util.List;
/*    */ import java.util.Map;
/*    */ import org.w3c.dom.Element;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ public class SVGPaintDescriptor
/*    */   implements SVGDescriptor, SVGSyntax
/*    */ {
/*    */   private Element def;
/*    */   private String paintValue;
/*    */   private String opacityValue;
/*    */   
/*    */   public SVGPaintDescriptor(String paintValue, String opacityValue) {
/* 42 */     this.paintValue = paintValue;
/* 43 */     this.opacityValue = opacityValue;
/*    */   }
/*    */ 
/*    */ 
/*    */   
/*    */   public SVGPaintDescriptor(String paintValue, String opacityValue, Element def) {
/* 49 */     this(paintValue, opacityValue);
/* 50 */     this.def = def;
/*    */   }
/*    */ 
/*    */   
/* 54 */   public String getPaintValue() { return this.paintValue; }
/*    */ 
/*    */ 
/*    */   
/* 58 */   public String getOpacityValue() { return this.opacityValue; }
/*    */ 
/*    */ 
/*    */   
/* 62 */   public Element getDef() { return this.def; }
/*    */ 
/*    */   
/*    */   public Map getAttributeMap(Map attrMap) {
/* 66 */     if (attrMap == null) {
/* 67 */       attrMap = new HashMap();
/*    */     }
/* 69 */     attrMap.put("fill", this.paintValue);
/* 70 */     attrMap.put("stroke", this.paintValue);
/* 71 */     attrMap.put("fill-opacity", this.opacityValue);
/* 72 */     attrMap.put("stroke-opacity", this.opacityValue);
/*    */     
/* 74 */     return attrMap;
/*    */   }
/*    */   
/*    */   public List getDefinitionSet(List defSet) {
/* 78 */     if (defSet == null) {
/* 79 */       defSet = new LinkedList();
/*    */     }
/* 81 */     if (this.def != null) {
/* 82 */       defSet.add(this.def);
/*    */     }
/* 84 */     return defSet;
/*    */   }
/*    */ }


/* Location:              C:\Program Files (x86)\IBM\WebSphere\AppServer\profiles\ctgAppSrv01\installedApps\ctgCell01\MAXIMO.ear\maximouiweb.war\WEB-INF\classes\!\com\ibm\tivoli\maximo\report\control\svgtools\batik-svggen.jar!\org\apache\batik\svggen\SVGPaintDescriptor.class
 * Java compiler version: 1 (45.3)
 * JD-Core Version:       1.0.7
 */