/*    */ package org.apache.batik.svggen.font;
/*    */ 
/*    */ import org.apache.batik.svggen.font.table.GlyphDescription;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ public class Glyph
/*    */ {
/*    */   protected short leftSideBearing;
/*    */   protected int advanceWidth;
/*    */   private Point[] points;
/*    */   
/*    */   public Glyph(GlyphDescription gd, short lsb, int advance) {
/* 36 */     this.leftSideBearing = lsb;
/* 37 */     this.advanceWidth = advance;
/* 38 */     describe(gd);
/*    */   }
/*    */ 
/*    */   
/* 42 */   public int getAdvanceWidth() { return this.advanceWidth; }
/*    */ 
/*    */ 
/*    */   
/* 46 */   public short getLeftSideBearing() { return this.leftSideBearing; }
/*    */ 
/*    */ 
/*    */   
/* 50 */   public Point getPoint(int i) { return this.points[i]; }
/*    */ 
/*    */ 
/*    */   
/* 54 */   public int getPointCount() { return this.points.length; }
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */   
/*    */   public void reset() {}
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */   
/*    */   public void scale(int factor) {
/* 67 */     for (int i = 0; i < this.points.length; i++) {
/*    */ 
/*    */       
/* 70 */       (this.points[i]).x = ((this.points[i]).x << 10) * factor >> 26;
/* 71 */       (this.points[i]).y = ((this.points[i]).y << 10) * factor >> 26;
/*    */     } 
/* 73 */     this.leftSideBearing = (short)(this.leftSideBearing * factor >> 6);
/* 74 */     this.advanceWidth = this.advanceWidth * factor >> 6;
/*    */   }
/*    */ 
/*    */ 
/*    */ 
/*    */   
/*    */   private void describe(GlyphDescription gd) {
/* 81 */     int endPtIndex = 0;
/* 82 */     this.points = new Point[gd.getPointCount() + 2];
/* 83 */     for (int i = 0; i < gd.getPointCount(); i++) {
/* 84 */       boolean endPt = (gd.getEndPtOfContours(endPtIndex) == i);
/* 85 */       if (endPt) {
/* 86 */         endPtIndex++;
/*    */       }
/* 88 */       this.points[i] = new Point(gd.getXCoordinate(i), gd.getYCoordinate(i), ((gd.getFlags(i) & true) != 0), endPt);
/*    */     } 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */     
/* 96 */     this.points[gd.getPointCount()] = new Point(0, 0, true, true);
/* 97 */     this.points[gd.getPointCount() + 1] = new Point(this.advanceWidth, 0, true, true);
/*    */   }
/*    */ }


/* Location:              C:\Program Files (x86)\IBM\WebSphere\AppServer\profiles\ctgAppSrv01\installedApps\ctgCell01\MAXIMO.ear\maximouiweb.war\WEB-INF\classes\!\com\ibm\tivoli\maximo\report\control\svgtools\batik-svggen.jar!\org\apache\batik\svggen\font\Glyph.class
 * Java compiler version: 1 (45.3)
 * JD-Core Version:       1.0.7
 */