/*    */ package org.apache.batik.svggen.font.table;
/*    */ 
/*    */ import java.io.IOException;
/*    */ import java.io.RandomAccessFile;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ public class FeatureList
/*    */ {
/*    */   private int featureCount;
/*    */   private FeatureRecord[] featureRecords;
/*    */   private Feature[] features;
/*    */   
/*    */   public FeatureList(RandomAccessFile raf, int offset) throws IOException {
/* 37 */     raf.seek(offset);
/* 38 */     this.featureCount = raf.readUnsignedShort();
/* 39 */     this.featureRecords = new FeatureRecord[this.featureCount];
/* 40 */     this.features = new Feature[this.featureCount];
/* 41 */     for (int i = 0; i < this.featureCount; i++) {
/* 42 */       this.featureRecords[i] = new FeatureRecord(raf);
/*    */     }
/* 44 */     for (int i = 0; i < this.featureCount; i++) {
/* 45 */       this.features[i] = new Feature(raf, offset + this.featureRecords[i].getOffset());
/*    */     }
/*    */   }
/*    */   
/*    */   public Feature findFeature(LangSys langSys, String tag) {
/* 50 */     if (tag.length() != 4) {
/* 51 */       return null;
/*    */     }
/* 53 */     int tagVal = tag.charAt(0) << '\030' | tag.charAt(1) << '\020' | tag.charAt(2) << '\b' | tag.charAt(3);
/*    */ 
/*    */ 
/*    */     
/* 57 */     for (int i = 0; i < this.featureCount; i++) {
/* 58 */       if (this.featureRecords[i].getTag() == tagVal && 
/* 59 */         langSys.isFeatureIndexed(i)) {
/* 60 */         return this.features[i];
/*    */       }
/*    */     } 
/*    */     
/* 64 */     return null;
/*    */   }
/*    */ }


/* Location:              C:\Program Files (x86)\IBM\WebSphere\AppServer\profiles\ctgAppSrv01\installedApps\ctgCell01\MAXIMO.ear\maximouiweb.war\WEB-INF\classes\!\com\ibm\tivoli\maximo\report\control\svgtools\batik-svggen.jar!\org\apache\batik\svggen\font\table\FeatureList.class
 * Java compiler version: 1 (45.3)
 * JD-Core Version:       1.0.7
 */