/*     */ package org.apache.batik.svggen.font.table;
/*     */ 
/*     */ import java.io.IOException;
/*     */ import java.io.RandomAccessFile;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class GsubTable
/*     */   implements Table, LookupSubtableFactory
/*     */ {
/*     */   private ScriptList scriptList;
/*     */   private FeatureList featureList;
/*     */   private LookupList lookupList;
/*     */   
/*     */   protected GsubTable(DirectoryEntry de, RandomAccessFile raf) throws IOException {
/*  36 */     raf.seek(de.getOffset());
/*     */ 
/*     */     
/*  39 */     raf.readInt();
/*  40 */     int scriptListOffset = raf.readUnsignedShort();
/*  41 */     int featureListOffset = raf.readUnsignedShort();
/*  42 */     int lookupListOffset = raf.readUnsignedShort();
/*     */ 
/*     */     
/*  45 */     this.scriptList = new ScriptList(raf, de.getOffset() + scriptListOffset);
/*     */ 
/*     */     
/*  48 */     this.featureList = new FeatureList(raf, de.getOffset() + featureListOffset);
/*     */ 
/*     */     
/*  51 */     this.lookupList = new LookupList(raf, de.getOffset() + lookupListOffset, this);
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public LookupSubtable read(int type, RandomAccessFile raf, int offset) throws IOException {
/*  64 */     LookupSubtable s = null;
/*  65 */     switch (type) {
/*     */       case 1:
/*  67 */         s = SingleSubst.read(raf, offset);
/*     */         break;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */       
/*     */       case 4:
/*  76 */         s = LigatureSubst.read(raf, offset);
/*     */         break;
/*     */     } 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */     
/*  85 */     return s;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*  92 */   public int getType() { return 1196643650; }
/*     */ 
/*     */ 
/*     */   
/*  96 */   public ScriptList getScriptList() { return this.scriptList; }
/*     */ 
/*     */ 
/*     */   
/* 100 */   public FeatureList getFeatureList() { return this.featureList; }
/*     */ 
/*     */ 
/*     */   
/* 104 */   public LookupList getLookupList() { return this.lookupList; }
/*     */ 
/*     */ 
/*     */   
/* 108 */   public String toString() { return "GSUB"; }
/*     */ }


/* Location:              C:\Program Files (x86)\IBM\WebSphere\AppServer\profiles\ctgAppSrv01\installedApps\ctgCell01\MAXIMO.ear\maximouiweb.war\WEB-INF\classes\!\com\ibm\tivoli\maximo\report\control\svgtools\batik-svggen.jar!\org\apache\batik\svggen\font\table\GsubTable.class
 * Java compiler version: 1 (45.3)
 * JD-Core Version:       1.0.7
 */