/*     */ package org.apache.batik.svggen.font.table;
/*     */ 
/*     */ import java.io.ByteArrayInputStream;
/*     */ import java.io.IOException;
/*     */ import java.io.RandomAccessFile;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class HmtxTable
/*     */   implements Table
/*     */ {
/*     */   private byte[] buf;
/*     */   private int[] hMetrics;
/*     */   private short[] leftSideBearing;
/*     */   
/*     */   protected HmtxTable(DirectoryEntry de, RandomAccessFile raf) throws IOException {
/*  31 */     this.buf = null;
/*  32 */     this.hMetrics = null;
/*  33 */     this.leftSideBearing = null;
/*     */ 
/*     */     
/*  36 */     raf.seek(de.getOffset());
/*  37 */     this.buf = new byte[de.getLength()];
/*  38 */     raf.read(this.buf);
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void init(int numberOfHMetrics, int lsbCount) {
/*  57 */     if (this.buf == null) {
/*     */       return;
/*     */     }
/*  60 */     this.hMetrics = new int[numberOfHMetrics];
/*  61 */     ByteArrayInputStream bais = new ByteArrayInputStream(this.buf);
/*  62 */     for (int i = 0; i < numberOfHMetrics; i++)
/*     */     {
/*     */       
/*  65 */       this.hMetrics[i] = bais.read() << 24 | bais.read() << 16 | bais.read() << 8 | bais.read();
/*     */     }
/*     */     
/*  68 */     if (lsbCount > 0) {
/*  69 */       this.leftSideBearing = new short[lsbCount];
/*  70 */       for (int i = 0; i < lsbCount; i++) {
/*  71 */         this.leftSideBearing[i] = (short)(bais.read() << 8 | bais.read());
/*     */       }
/*     */     } 
/*  74 */     this.buf = null;
/*     */   }
/*     */   
/*     */   public int getAdvanceWidth(int i) {
/*  78 */     if (this.hMetrics == null) {
/*  79 */       return 0;
/*     */     }
/*  81 */     if (i < this.hMetrics.length) {
/*  82 */       return this.hMetrics[i] >> 16;
/*     */     }
/*  84 */     return this.hMetrics[this.hMetrics.length - 1] >> 16;
/*     */   }
/*     */ 
/*     */   
/*     */   public short getLeftSideBearing(int i) {
/*  89 */     if (this.hMetrics == null) {
/*  90 */       return 0;
/*     */     }
/*  92 */     if (i < this.hMetrics.length) {
/*  93 */       return (short)(this.hMetrics[i] & 0xFFFF);
/*     */     }
/*  95 */     return this.leftSideBearing[i - this.hMetrics.length];
/*     */   }
/*     */ 
/*     */ 
/*     */   
/* 100 */   public int getType() { return 1752003704; }
/*     */ }


/* Location:              C:\Program Files (x86)\IBM\WebSphere\AppServer\profiles\ctgAppSrv01\installedApps\ctgCell01\MAXIMO.ear\maximouiweb.war\WEB-INF\classes\!\com\ibm\tivoli\maximo\report\control\svgtools\batik-svggen.jar!\org\apache\batik\svggen\font\table\HmtxTable.class
 * Java compiler version: 1 (45.3)
 * JD-Core Version:       1.0.7
 */