/*    */ package org.apache.batik.svggen.font.table;
/*    */ 
/*    */ import java.io.IOException;
/*    */ import java.io.RandomAccessFile;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ public class ScriptList
/*    */ {
/*    */   private int scriptCount;
/*    */   private ScriptRecord[] scriptRecords;
/*    */   private Script[] scripts;
/*    */   
/*    */   protected ScriptList(RandomAccessFile raf, int offset) throws IOException {
/* 31 */     this.scriptCount = 0;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */     
/* 37 */     raf.seek(offset);
/* 38 */     this.scriptCount = raf.readUnsignedShort();
/* 39 */     this.scriptRecords = new ScriptRecord[this.scriptCount];
/* 40 */     this.scripts = new Script[this.scriptCount];
/* 41 */     for (int i = 0; i < this.scriptCount; i++) {
/* 42 */       this.scriptRecords[i] = new ScriptRecord(raf);
/*    */     }
/* 44 */     for (int i = 0; i < this.scriptCount; i++) {
/* 45 */       this.scripts[i] = new Script(raf, offset + this.scriptRecords[i].getOffset());
/*    */     }
/*    */   }
/*    */ 
/*    */   
/* 50 */   public int getScriptCount() { return this.scriptCount; }
/*    */ 
/*    */ 
/*    */   
/* 54 */   public ScriptRecord getScriptRecord(int i) { return this.scriptRecords[i]; }
/*    */ 
/*    */   
/*    */   public Script findScript(String tag) {
/* 58 */     if (tag.length() != 4) {
/* 59 */       return null;
/*    */     }
/* 61 */     int tagVal = tag.charAt(0) << '\030' | tag.charAt(1) << '\020' | tag.charAt(2) << '\b' | tag.charAt(3);
/*    */ 
/*    */ 
/*    */     
/* 65 */     for (int i = 0; i < this.scriptCount; i++) {
/* 66 */       if (this.scriptRecords[i].getTag() == tagVal) {
/* 67 */         return this.scripts[i];
/*    */       }
/*    */     } 
/* 70 */     return null;
/*    */   }
/*    */ }


/* Location:              C:\Program Files (x86)\IBM\WebSphere\AppServer\profiles\ctgAppSrv01\installedApps\ctgCell01\MAXIMO.ear\maximouiweb.war\WEB-INF\classes\!\com\ibm\tivoli\maximo\report\control\svgtools\batik-svggen.jar!\org\apache\batik\svggen\font\table\ScriptList.class
 * Java compiler version: 1 (45.3)
 * JD-Core Version:       1.0.7
 */