/*    */ package org.apache.batik.svggen.font.table;
/*    */ 
/*    */ import java.io.IOException;
/*    */ import java.io.RandomAccessFile;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ public class TableDirectory
/*    */ {
/*    */   private int version;
/*    */   private short numTables;
/*    */   private short searchRange;
/*    */   private short entrySelector;
/*    */   private short rangeShift;
/*    */   private DirectoryEntry[] entries;
/*    */   
/*    */   public TableDirectory(RandomAccessFile raf) throws IOException {
/* 30 */     this.version = 0;
/* 31 */     this.numTables = 0;
/* 32 */     this.searchRange = 0;
/* 33 */     this.entrySelector = 0;
/* 34 */     this.rangeShift = 0;
/*    */ 
/*    */ 
/*    */     
/* 38 */     this.version = raf.readInt();
/* 39 */     this.numTables = raf.readShort();
/* 40 */     this.searchRange = raf.readShort();
/* 41 */     this.entrySelector = raf.readShort();
/* 42 */     this.rangeShift = raf.readShort();
/* 43 */     this.entries = new DirectoryEntry[this.numTables];
/* 44 */     for (int i = 0; i < this.numTables; i++) {
/* 45 */       this.entries[i] = new DirectoryEntry(raf);
/*    */     }
/*    */ 
/*    */     
/* 49 */     boolean modified = true;
/* 50 */     while (modified) {
/* 51 */       modified = false;
/* 52 */       for (int i = 0; i < this.numTables - 1; i++) {
/* 53 */         if (this.entries[i].getOffset() > this.entries[i + 1].getOffset()) {
/* 54 */           DirectoryEntry temp = this.entries[i];
/* 55 */           this.entries[i] = this.entries[i + 1];
/* 56 */           this.entries[i + 1] = temp;
/* 57 */           modified = true;
/*    */         } 
/*    */       } 
/*    */     } 
/*    */   }
/*    */ 
/*    */   
/* 64 */   public DirectoryEntry getEntry(int index) { return this.entries[index]; }
/*    */ 
/*    */   
/*    */   public DirectoryEntry getEntryByTag(int tag) {
/* 68 */     for (int i = 0; i < this.numTables; i++) {
/* 69 */       if (this.entries[i].getTag() == tag) {
/* 70 */         return this.entries[i];
/*    */       }
/*    */     } 
/* 73 */     return null;
/*    */   }
/*    */ 
/*    */   
/* 77 */   public short getEntrySelector() { return this.entrySelector; }
/*    */ 
/*    */ 
/*    */   
/* 81 */   public short getNumTables() { return this.numTables; }
/*    */ 
/*    */ 
/*    */   
/* 85 */   public short getRangeShift() { return this.rangeShift; }
/*    */ 
/*    */ 
/*    */   
/* 89 */   public short getSearchRange() { return this.searchRange; }
/*    */ 
/*    */ 
/*    */   
/* 93 */   public int getVersion() { return this.version; }
/*    */ }


/* Location:              C:\Program Files (x86)\IBM\WebSphere\AppServer\profiles\ctgAppSrv01\installedApps\ctgCell01\MAXIMO.ear\maximouiweb.war\WEB-INF\classes\!\com\ibm\tivoli\maximo\report\control\svgtools\batik-svggen.jar!\org\apache\batik\svggen\font\table\TableDirectory.class
 * Java compiler version: 1 (45.3)
 * JD-Core Version:       1.0.7
 */